local assets=
{
	Asset("ANIM", "anim/hat_plantregistry.zip"),
    Asset("ATLAS", "images/inventoryimages/hat_plantregistry.xml"),
}
local function onfinished(inst)
    inst:Remove()
end
local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_hat", "hat_plantregistry", "swap_hat")
    owner.AnimState:Show("HAT")
    owner.AnimState:Show("HAIR_HAT")
    owner.AnimState:Hide("HAIR_NOHAT")
    owner.AnimState:Hide("HAIR")
    if GetPlayer().prefab ~=  "wormwood" then
        owner:AddTag("plantkin")
        if owner.killedplantfn == nil then
            owner.killedplantfn = function()
            end
        end
        owner.growplantfn = function(owner)
            owner.components.hunger:DoDelta(-5)
            inst.components.finiteuses:Use(1)
        end
    else
        owner.growplantfn = function (owner, bonus)
            if bonus then 
                owner.components.sanity:DoDelta(bonus)
            else
                owner.components.sanity:DoDelta(TUNING.SANITY_TINY)
            end	
            owner.components.health:DoDelta(2)
            owner.components.sanity:DoDelta(TUNING.SANITY_TINY)
            inst.components.finiteuses:Use(1)
            GetPlayer().components.talker:Say(GetString(GetPlayer().prefab, "ANNOUNCE_GROWPLANT"))            
        end
    end
end
local function onunequip(inst, owner)
	owner.AnimState:Hide("HAT")
	owner.AnimState:Hide("HAT_HAIR")
	owner.AnimState:Show("HAIR_NOHAT")
	owner.AnimState:Show("HAIR")
    if owner:HasTag("player") then
        owner.AnimState:Show("HEAD")
        owner.AnimState:Hide("HEAD_HAIR")
    end
    if owner.prefab ~= "wormwood" then
        owner:RemoveTag("plantkin")
        owner.growplantfn = nil
        owner.killedplantfn = nil
    else
        owner.growplantfn = function (owner, bonus)
            if bonus then 
                owner.components.sanity:DoDelta(bonus)
            else
                owner.components.sanity:DoDelta(TUNING.SANITY_TINY)
            end	
            owner.components.sanity:DoDelta(TUNING.SANITY_TINY)
            GetPlayer().components.talker:Say(GetString(GetPlayer().prefab, "ANNOUNCE_GROWPLANT"))            
        end
    end
end
local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	MakeInventoryPhysics(inst)
	inst:AddTag("hat")
    anim:SetBank("footballhat")
    anim:SetBuild("hat_plantregistry")
	anim:PlayAnimation("anim")
	inst:AddTag("floatmoddedfood")
	inst.hcp_shelfart = true
	if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then
		MakeInventoryFloatable(inst)
	end
    inst:AddComponent("inspectable")
    inst:AddComponent("inventoryitem")
    inst:AddComponent("equippable")
    inst.components.equippable.equipslot = EQUIPSLOTS.HEAD
    return inst
end
local function hat_plantregistry(Sim)
    local inst = fn(Sim)
	inst.components.inventoryitem.imagename = "hat_plantregistry"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/hat_plantregistry.xml"
    inst:AddComponent("finiteuses")
	inst.components.finiteuses:SetMaxUses(20)
    inst.components.finiteuses:SetPercent(1)
	inst.components.finiteuses:SetOnFinished( function(inst)
        inst:Remove()
    end)
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )
    return inst
end
STRINGS.NAMES.HAT_PLANTREGISTRY = "Gardener Hat"
STRINGS.RECIPE_DESC.HAT_PLANTREGISTRY = "Help you to plant."
STRINGS.CHARACTERS.GENERIC.DESCRIBE.HAT_PLANTREGISTRY = "Ready to work!"

return Prefab( 'hat_plantregistry', hat_plantregistry, assets)
